include:
{%- set os=grains['os'] -%}
{%- if os=="CentOS" or os=="RedHat" %}
  - repos.nginx
  - repos.webtatic
{% endif %}

php.packages:
  pkg.installed:
    - pkgs:
      - php56w
      - php56w-mbstring
      - php56w-mysql
      - php56w-mcrypt
      - php56w-fpm
      - php56w-xml
 
install_mariadb:
  pkg.installed:
    - pkgs:
      - mariadb-server

selinux-policy-targeted:
  pkg.installed

policycoreutils-python:
  pkg.installed

httpd_can_network_connect:
  selinux.boolean:
    - value: True
    - persist: True

/root/salt/scripts/build_pepper.sh:
  file.managed:
    - makedirs: true
    - source: salt://roles/build/pepper/build_pepper.sh
    - user: root
    - group: root
    - mode: 744

build_pepper:
  cmd.run:
    - name: "sh /root/salt/scripts/build_pepper.sh"

install_nginx:
  pkg.installed:
    - name: nginx
