#/bin/bash

c=`ps aux | grep chaussette | wc -l`

function stop {
  if [ c -gt 1 ];
  then
    echo "Stopping server.."
    pkill chaussette
    echo ".. Done."
  else
    echo "Server not running"
  fi
}

function start {
  if [c -gt 1 ]
  then
    echo "Server is already running"
  else
    echo "Starting Server.."
    cd /opt/saltpad
    source venv/bin/activate
    chaussette saltpad.merged:app &
    echo ".. Done."
  fi
}

function restart {
  echo "Restarting server.."
  if [ c -gt 1 ]
  then
    stop
    sleep 5
    start
  else
    start
  fi
  echo ".. Done."
}

function status {
  if [ c -gt 1 ]
  then
    echo "Server is not running"
    exit 1
  else
    echo "Server is running"
  fi
}

case "$1" in
   start)
      start
   ;;
   stop)
      stop
   ;;
   restart)
      restart
   ;;
   status)
      status
   ;;
   *)
      echo "Usage: $0 {start|stop|restart|status}"
esac
