salt-api:
  pkg.installed: []
  service.running:
    - enable: true

saltpad:
  service.running:
    - enable: true
    - watch:
      - cmd: "sh /root/salt/scripts/merge.sh"

nginx:
  service.running:
    - enable: true
    - watch:
      - file: /etc/nginx/conf.d/*

/etc/nginx/conf.d/:
  file.recurse:
    - source: salt://roles/maintain/saltpad/conf.d/
    - user: root
    - group: root
    - dir_mode: 755
    - file_mode: 644
    - clean: true

/root/salt/scripts/merge.sh:
  file.managed:
    - makedirs: true
    - source: salt://roles/maintain/saltpad/merge.sh
    - user: root
    - group: root
    - mode: 744

/opt/saltpad/saltpad/modules/:
  file.recurse:
    - source: salt://roles/maintain/saltpad/modules/
    - user: root
    - group: root
    - dir_mode: 755
    - file_mode: 644
    - clean: true

"sh /root/salt/scripts/merge.sh":
  cmd.wait:
    - watch:
      - file: /opt/saltpad/saltpad/modules/*
    - require:
      - file: /root/salt/scripts/merge.sh

/opt/saltpad/saltpad/templates/:
  file.recurse:
    - source: salt://roles/maintain/saltpad/templates/
    - user: root
    - group: root
    - dir_mode: 755
    - file_mode: 644
